/**************************************************************************/
/***    ADM-676PCI(WDM) Sample Header :			                ***/
/***                                           (C) MICRO SCIENCE        ***/
/***	2001.07.28	First Rel.                                      ***/
/**************************************************************************/
#ifdef __cplusplus
	extern "C" {
#endif

#define BOARD_NAME	"ADM-676PCI"
#define VENDOR_ID	0x13FD
#define	DEVICE_ID	0x0103
#define	BOARD_ID	0x0A
#define	MAX_CH		16

#define FIFO_HALF	512		/* Normaly */

#define	DATA		0x00
#define TRIG		0x06
#define TRIG_LEVEL1	0x0c
#define TRIG_LEVEL2	0x0e
#define	INTR		0x08
#define	INTR_CLR	0x02
#define	CLKSEL		0x10
#define	CLKDIV		0x12
#define	RESET		0x0e
#define	MODE		0x04
#define	AUX		0x14
#define STATUS		0x0a
#define STSCLR		0x0a
#define	MANUAL		0x0c
#define	ORDER		0x00

/* Mode */
#define	BIT_12		0
#define	BIT_14		1
#define	BIT_16		2
#define	MODE_A		0
#define	MODE_B		0x40
#define	SINGLE_END	0
#define	DIFFERENTIAL	0x20
#define	STRAGHT		0
#define	COMP_2S		0x10


#define	ENABLE		1
#define	DISABLE		0

/* External Controls */
#define	INTERRUPT	0x80
#define	RISING		0x40
#define	FOLLING		0x00
#define	SLAVE		0x20
#define	MASTER		0x00

/* CLKSEL */
#define EXT_RISE	0x90
#define EXT_FALL	0x10
#define INT_OPT		0x40
#define INT_8M		0x20
#define INT_10M		0x00

/* TRIG */
#define	SOFT_TRIG	0x81
#define	EXT_TRIG	0x41
#define	INT_TRIG	0x21
#define	PLUS		0x10
#define	MINUS		0x00
#define	EDGE		0x10
#define	LEVEL		0x00
#define	RANGE		0x08
#define	NONE_STOP	0x00
#define	STOP		0x00

/* Status */
#define	EOS_FLAG	0x80
#define	INTR_FLAG	0x40
#define	CLOCK_FLAG	0x20
#define	TRGD		0x10
#define BUSY_FLAG	0x08
#define	SMP_ERR		0x04
#define	NOT_HALF	0x02
#define	NOT_EMPTY	0x01

/* Mode */
#define	FIFO		0x02
#define	DIRECT		0x00
#define	DMA		0x03
#define	IO		0x00

/* RANGE */
#define	BP10		0x0
#define	BP5		0x4000
#define	UP10		0x8000
#define	UP5		0xc000

/* INTR */
#define	INTR_HALF_FULL	0x40
#define	INTR_NOT_EMPTY	0x20
#define	INTR_EOS	0x08
#define	INTR_TRGD	0x04
#define	INTR_EXT_RISE	0x82
#define	INTR_EXT_FALL	0x02
#define	INTR_CLOCK	0x01

/* INTROUT */
#define INTR_DIS	0x8
#define INTR_EN		0x0

#ifdef __cplusplus
	}
#endif
