/**************************************************************************/
/***    ADM-687ZPCI(WDM) Sample Header :			        ***/
/***                                           (C) MICRO SCIENCE        ***/
/***	2003.08.06	First Rel.                                      ***/
/**************************************************************************/
#ifdef __cplusplus
	extern "C" {
#endif

#define BOARD_NAME	"ADM-687zPCI"
#define VENDOR_ID	0x13FD
#define	DEVICE_ID	0x010A
#define	BOARD_ID	0x11
#define	MAX_CH		32

#define FIFO_HALF	512		/* Normaly */

/* Port */
#define	DATA		0
#define	CHNUM		0
#define	INTROUT		1
#define	DATACODE	2
#define TRIG		3
#define	INTRSRC		4
#define STATUS		5
#define STSCLR		5
#define	MANUAL		6
#define TRGLEVEL1	6
#define TRGLEVEL2	7
#define	RESET		7
#define	CLKSEL		8
#define	CLKDIV		9
#define	DIO		0x0A
#define BRDNUM		0x0B

/* External Controls */
//#define	INTERRUPT	0x80
//#define	RISING		0x40
//#define	FOLLING		0x00
//#define	SLAVE		0x20
//#define	MASTER		0x00

/* CLKSEL */
#define EXT_RISE	0x90
#define EXT_FALL	0x10
#define INT_OPT		0x40
#define INT_8M		0x20
#define INT_10M		0x00

/* TRIG */
#define	SOFT_TRIG	0x81
#define	EXT_TRIG	0x41
#define	INT_TRIG	0x21
#define	PLUS		0x10
#define	MINUS		0x00
#define	EDGE		0x08
#define	LEVEL		0x00
#define	RANGE		0x04
#define	SLOPE		0x0C
#define	STOP		0x00


/* Status */
#define	EOS_FLAG	0x80
#define	INTR_FLAG	0x40
#define	CLOCK_FLAG	0x20
#define	TRG_FLAG	0x10
#define EOM_FLAG        0x08
#define	SMP_ERR		0x04
#define	NOT_HALF	0x02
#define	NOT_EMPTY	0x01

/* DATACODE */
#define	STRAGHT		0x00
#define	COMP2		0x10
#define	HIGH_LOW	0x01		// [h̎Zbg

/* INTRSRC */
#define	INTR_HALF_FULL	0x40
#define	INTR_NOT_EMPTY	0x20
#define	INTR_EOS	0x08
#define	INTR_TRGD	0x04
#define	INTR_EXT_RISE	0x82
#define	INTR_EXT_FALL	0x02
#define	INTR_CLOCK	0x01

/* INTROUT */
#define	INTR_EN		0x01
#define	INTR_DIS	0x00

#ifdef __cplusplus
	}
#endif
