#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "adm686.h"

void close(void);
unsigned int analog_adjust(void);

int resource_no;

int main(int argc, char **argv)
{
	long splnum, count, divide, l, setnum;	/*  number of sampling, status */
	int chs;	/*  number of sampling, status */

	int	i, j, brd_num, rv, device_id[8], index[8], brd_no;
	WORD data, *buf_ptr;
	BYTE stat, cmdchar;
	DWORD start_time;
	BOOL quit, err;
	HGLOBAL hMem;

	printf("ADM-686PCI mFvOV1.2\n");

	switch (argc){
	case 1:
		brd_no = 0;
		break;
	case 2:
		sscanf(argv[1], "%d", &brd_no);
		break;
	default:
		printf("USAGE: TS686W2 board_no\n");
		return (-1);
	}

	for (i = 0; i <= 7; i++){
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0){
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0){
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);

	if (brd_num <= brd_no){
		printf("board_no̎w肪Ă܂B");
		close ();
	}

	rv = Start_Driver(index[brd_no], 2, &resource_no);
	if (rv != 0){
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		close();
	}

	data = ReadByte(resource_no, RESET);
	if (data != BOARD_ID){
		printf("{[hID(=%02xH)ُłB\n", data);
		close();
	}

    chs = MAX_CH;
	splnum = 200;
	
	// `lőɐݒ
	WriteByte(resource_no, CHNUM, (unsigned char)(chs - 1));

	/* select clock source */
	// POlggp
	WriteByte(resource_no, CLKSEL, INT_10M);

	// NbNQOʂr^`lɐݒ
	WriteByte(resource_no, CLKDIV, 0x80);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x0c);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x01);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE
	
	/* make buffer area */
	hMem = GlobalAlloc(GHND, splnum * 2 * chs);
	buf_ptr = (LPWORD)GlobalLock(hMem);
	if (buf_ptr == 0L){
		printf("Not enough memory.\n");
		return (-1);
	}

	/* start sampling */
	WriteByte(resource_no, TRIG, SOFT_TRIG);

	/* loop for read data */
	setnum = FIFO_HALF / chs;
	count = 0L;
	l = 0L;
	do{
		stat = ReadByte(resource_no, STATUS);
		if (stat & SMP_ERR){
			WriteByte(resource_no, TRIG, STOP);	/* A/D stop */
			printf("Sampling Error in half full sampling!!\n");
			GlobalUnlock(hMem);
			GlobalFree(hMem);
			exit(1);
		}
	  	else if ((stat & NOT_HALF) != NOT_HALF){
			ReadByteBlock(resource_no, DATA, setnum * chs * 2, (BYTE *)(buf_ptr + l));
			l += setnum * chs;
			++count;
		}
		else
			;
	} while (count < (splnum / setnum));

	do{
		stat = ReadByte(resource_no, STATUS);
		if (stat & SMP_ERR){
			WriteByte(resource_no, TRIG, STOP);	/* A/D stop */
			printf("Sampling Error in not empty sampling!!\n");
			GlobalUnlock(hMem);
			GlobalFree(hMem);
			exit(1);
		}
		else if(stat & EOS_FLAG){
			WriteByte(resource_no, STSCLR, EOS_FLAG);
			ReadByteBlock(resource_no, DATA, chs * 2, (BYTE *)(buf_ptr + l));
			l += chs;
		}
		else
			;
	}while (l < splnum * chs);
	
	/*  display sampled data  */
	for (l = 0L; l < splnum; l++){
		for (i = 0; i < chs; i++)
			printf("%04x ", *(buf_ptr + l * chs + i));
		printf("\n");
	}

	GlobalUnlock(hMem);
	GlobalFree(hMem);
	printf("\nsꍇ\"C/c\"L[AIꍇ\"E/e\"L[ĉB\n");
	do{
		cmdchar = getch();
	}while(cmdchar != 'E' & cmdchar != 'e' & cmdchar != 'C' & cmdchar != 'c');
	if (cmdchar == 'E' | cmdchar == 'e')
		;
	else {
		printf("TvOJnɂSL[ĉB\n܂TvOI鎞͉L[ĉB\n");
		do{
			cmdchar = getch();
		}while(cmdchar != 'S' & cmdchar != 's');
		analog_adjust();
		cmdchar = getch();
	}
	return (0);
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0){
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}
unsigned int	analog_adjust( void )
{
	int chs, i, l;	/*  number of sampling, status */
	unsigned char stat;
	WORD data[MAX_CH], *data_ptr;

	chs = MAX_CH;
	data_ptr = &data[0];
	
	do{
		stat = ReadByte(resource_no, RESET);	// {[hďs
		// `lőɐݒ
		WriteByte(resource_no, CHNUM, (unsigned char)(chs - 1));

		/* select clock source */
		// POlggp
		WriteByte(resource_no, CLKSEL, INT_10M);

		// NbNQOr^`lɐݒ
		WriteByte(resource_no, CLKDIV, 0x80);	// JE^`BYTE
		WriteByte(resource_no, CLKDIV, 0x0C);	// JE^`BYTE
		WriteByte(resource_no, CLKDIV, 0x01);	// JE^aBYTE
		WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE

		/* start sampling */
		ReadByte(resource_no, MANUAL);

		/* loop for read data */
		l = 0;

		do{
			stat = ReadByte(resource_no, STATUS);
			if(stat & SMP_ERR){
				WriteByte(resource_no, TRIG, STOP);
				printf("Sampling Error in not empty sampling!!\n");
				return(1);
			}
			else if(stat & EOS_FLAG){
				WriteByte(resource_no, STSCLR, EOS_FLAG);
				ReadByteBlock(resource_no, DATA, chs * 2, (BYTE *)data_ptr);
				l += chs;
			}
			else
				;
		}while (l < chs);

		/*  display sampled data  */
		for (i = 0; i < chs; i++)
			printf("%02d-%04x ", i , data[i]);
		printf("\n");
	}while(!_kbhit());
	return(0);
}
